DAT objectName          byte "HeaderDemo_131209a", 0
robotName               byte "Demo Program", 0
  
CON
{{
  ******* Public Notes *******
  
}}
{
  ******* Private Notes *******

  HeaderVexTreads130130a modified DemoFourMotorsAndEncoders130130a
  130130a Move individual robot constants to a header file
  to make it easy to use the same code with multiple robots.
  25a Add constants used in HeaderRover5_130225a
  27a Add compass support.
  0308a Add master/slave support.
  0322a Add encoder modes. The FULL_SPEED constant value
  changed since the new version of the encoer method changed
  the value of the measured speed.
  0415a Change for pins used on dual Propeller board.
  
} 
  WHEEL_RED_0 = -1         ' The "RED" constants don't have to be assigned to
  WHEEL_BLACK_0 = -1       ' red wires. It may be useful to switch the pin
  WHEEL_RED_1 = -1         ' assignments if the wheel direction doesn't match
  WHEEL_BLACK_1 = -1       ' the encoder directions.
  WHEEL_RED_2 = -1         ' Set to "-1" if a motor isn't being used.
  WHEEL_BLACK_2 = -1       ' If any of the three motor control pins is
  WHEEL_RED_3 = -1         ' is set to -1, the motor will not receive a PWM
  WHEEL_BLACK_3 = -1       ' signal.
  
  FIRST_ENCODER_0 = 4     ' The next I/O pin higher will also be used.
  FIRST_ENCODER_1 = 6     ' Example: the encoder for motor #1 will use pins 2 and 3.
  FIRST_ENCODER_2 = -1    ' Set to "-1" if a motor isn't being used.
  FIRST_ENCODER_3 = -1
  WHEEL_ENABLE_0 = -1 
  WHEEL_ENABLE_1 = -1  
  WHEEL_ENABLE_2 = -1 
  WHEEL_ENABLE_3 = -1

  FORWARD0 = 1          ' If forward robot movement produces negative speed,
  FORWARD1 = 1          ' then the FORWARDx should be set to "-1".
  FORWARD2 = 1          ' Otherwise these should be set to "1".
  FORWARD3 = 1
  FULL_SPEED = 28 '69       ' Measured with PROPORTIONAL_CONSTANT set to zero and
                        ' target speeds set to max allowed (usually 1000).
  MAX_TRANSITIONS_PER_SEC = 10827 '282 '
  ' 1000 transitions per three rotations

  TRANS_PER_REV_NUMERATOR = 4331 '1000
  TRANS_PER_REV_DENOMINATOR = 1 '3          
                        
  FULL_SPEED_TIMED = 690                      
  PSEUDOREAL_MULTIPLIER = 100 ' If the multiplier is too large values used in calculations
                              ' could exceed 32-bits.
  PSEUDO_FULL_SPEED = FULL_SPEED * PSEUDOREAL_MULTIPLIER
  DEFAULT_ACCELERATION = 30 '40 '20 '12 '8
  PSEUDO_ACCELERATION = DEFAULT_ACCELERATION * PSEUDOREAL_MULTIPLIER
  REFRESH_RATE = 50
  PID_INCREASE = 10  ' to give added precision to proportional constant
  PID_MULTIPLIER = PSEUDOREAL_MULTIPLIER * PID_INCREASE
  PSEUDO_DT = 75   ' not presently used
  PROPORTIONAL_CONSTANT = 10
  INTEGRAL_CONSTANT = 0 '1 ' not presently used
  MAX_INTEGRAL = 12000 '2000  
  DERIVATIVE_CONSTANT = 0  ' not presently used

  
  DEFAULT_SPEED = 150 '450 '600    ' Used in figure 8 not presently calibrated
                              
  DEFAULT_TURN_RATE = 100 '25 'DEFAULT_SPEED / 2 '4  ' Used in figure 8, the larger the turn rate 
                                            ' the larger the loops of the figure 8 will
                                            ' be.
                                            
  STEPS_PER_FIGURE_8 = REFRESH_RATE * 40 '1045 ' Used in figure 8, divide by refresh rate to
                            ' compute seconds of driving.
  ' phaseOf8 enumeration 
  #0, START_1ST_LOOP, WATCH_FOR_END_1ST_LOOP, EXTEND_1ST_LOOP, {
  } START_2ND_LOOP, WATCH_FOR_END_2ND_LOOP, EXTEND_2ND_LOOP, FINISHED_LOOP
                                              
  ' stepsOf8 
  START_1ST_STEPS = REFRESH_RATE * 2 'STEPS_PER_FIGURE_8 / 8 ' quarter circle
  WATCH_FOR_END_1ST_STEPS = 10000'(STEPS_PER_FIGURE_8 / 2) - START_1ST_STEPS'START_1ST_STEPS * 3
  EXTEND_1ST_STEPS = STEPS_PER_FIGURE_8 / 4
  START_2ND_STEPS = START_1ST_STEPS
  WATCH_FOR_END_2ND_STEPS = WATCH_FOR_END_1ST_STEPS
  EXTEND_2ND_STEPS = EXTEND_1ST_STEPS
  WAIT_FOR_8_TIME = REFRESH_RATE * 4 ' four seconds
  

  MIN_STEPS = STEPS_PER_FIGURE_8
  MAX_STEPS = STEPS_PER_FIGURE_8 * 100
                           
  #0, COUNTER_CLOCKWISE_TURN, CLOCKWISE_TURN
                            
  FIRST_LOOP_TURN_DIRECTION = COUNTER_CLOCKWISE_TURN

PUB GetObjectName

  result := @objectName

PUB GetRobotName

  result := @robotName
 
PUB GetEncoderPins

  result := @encoderPin
  
PUB GetEnablePins

  result := @enablePin
  
PUB GetRedPins

  result := @redPin
  
PUB GetBlackPins

  result := @blackPin
  
PUB GetPidParameters

  result := @pidParameters

DAT

encoderPin    byte FIRST_ENCODER_0, FIRST_ENCODER_1, FIRST_ENCODER_2, FIRST_ENCODER_3
                          
DAT

enablePin     long WHEEL_ENABLE_0, WHEEL_ENABLE_1, WHEEL_ENABLE_2, WHEEL_ENABLE_3

DAT

redPin        long WHEEL_RED_0, WHEEL_RED_1, WHEEL_RED_2, WHEEL_RED_3

DAT

blackPin      long WHEEL_BLACK_0, WHEEL_BLACK_1, WHEEL_BLACK_2, WHEEL_BLACK_3
                          
DAT
      
pidParameters long PROPORTIONAL_CONSTANT, INTEGRAL_CONSTANT, DERIVATIVE_CONSTANT, PID_INCREASE
              long MAX_INTEGRAL

DAT '' License
{{
*********************************************************************************************
*                             TERMS OF USE: MIT License                                     *                                                                   
*********************************************************************************************
* Permission is hereby granted, free of charge, to any person obtaining a copy of this      *
* software and associated documentation files (the "Software"), to deal in the Software     *
* without restriction, including without limitation the rights to use, copy, modify,        *
* merge, publish, distribute, sublicense, and/or sell copies of the Software, and to        *
* permit persons to whom the Software is furnished to do so, subject to the following       *
* conditions:                                                                               *
*                                                                                           *                                    
* The above copyright notice and this permission notice shall be included in all copies or  *
* substantial portions of the Software.                                                     *
*                                                                                           *                                   
* The software is provided "as is", without warranty of any kind, express or implied,       *
* including but not limited to the warranties of merchantability, fitness for a particular  *
* and noninfringment. In no event shall the authors or copyright holders be liable for any  *
* claim, damages or other liability, whether in an action of contract, tort or otherwise,   *
* arising from, of or in connection with the software of the use of other dealings in the   *
* software.                                                                                 *
*********************************************************************************************
}}            